/* ------------------------------ testcon.c --------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include "com.h"

static int	status = 0;		/* com is off */
static int	nin = 0, nout = 0;

static void
die (int rc)
{
/* Shut com2 down.
*/
	if (status >= 2) {
		port_stop (2);
		status = 1;		/* com is on */
	}

/* Shut down the com system.
*/
	if (status >= 1) {
		com_stop (-1);
		status = 0;		/* com is off */
	}

	fprintf (stderr, "\n%d chars in, %d out\n", nin, nout);

	exit (rc);
}

int 
main ()
{
	int	ch;

/* First we initialise the com system.
*/
	if (com_start (-1, 0L, 0, 0, 0, 0)) {
		fprintf (stderr, "com init failed");
		die (1);
	}
	status = 1;			/* com is on */

/* Set com2 parameters.
*/
	if (port_set (
			2,		/* port number */
			1000,		/* input buffer size*/
			1000,		/* output buffer size */
			-1,		/* irq (use default) */
			-1		/* base (use default)*/
		)) {
		fprintf (stderr, "port set failed");
		die (1);
	}

/* Start com2.
*/
	if (port_start (
			2, 		/* port number */
			38400L,		/* line speed */
			'N',		/* parity (none) */
			8,		/* bits (8) */
			1,		/* stop bits (1) */
			'N'		/* XON/XOFF mode (none) */
		)) {
		fprintf (stderr, "port start failed");
		die (1);
	}
	status = 2;			/* com is on and active */

/* The test loop.
*/
	fprintf (stderr, "Hit Esc to stop\n\n");

	for (;;) {
		while ((ch = comin (2)) != -1) {
			putch (ch);
			++nin;
		}

		while (kbhit()) {
			ch = getch ();
			if (27 == ch)
				die (0);	/* stop on Esc char */
			if (0 != (ch = comout (2, ch))) {
				fprintf (stderr, "\ncomout failed %d\n", ch);
				break;
			}
			++nout;
		}
	}
	return (0);
}
